
! Copyright (C) 2011 J. K. Dewhurst, S. Sharma and E. K. U. Gross.
! This file is distributed under the terms of the GNU General Public License.
! See the file COPYING for license details.

subroutine dpotks
use modmain
use modphonon
implicit none
! local variables
integer is,ias,nr,nri
! allocatable arrays
complex(8), allocatable :: zfmt(:,:)
! convert density derivative to spherical coordinates
!$OMP PARALLEL DEFAULT(SHARED) PRIVATE(zfmt,is,nr,nri)
!$OMP DO
do ias=1,natmtot
  allocate(zfmt(lmmaxvr,nrmtmax))
  is=idxis(ias)
  nr=nrmt(is)
  nri=nrmtinr(is)
  call zfmtcopy(nr,nri,drhomt(:,:,ias),zfmt)
  call zbsht(nr,nri,zfmt,drhomt(:,:,ias))
  deallocate(zfmt)
end do
!$OMP END DO
!$OMP END PARALLEL
! compute the exchange-correlation potential derivative
call dpotxc
! convert density derivative to spherical harmonics
!$OMP PARALLEL DEFAULT(SHARED) PRIVATE(zfmt,is,nr,nri)
!$OMP DO
do ias=1,natmtot
  allocate(zfmt(lmmaxvr,nrmtmax))
  is=idxis(ias)
  nr=nrmt(is)
  nri=nrmtinr(is)
  call zfmtcopy(nr,nri,drhomt(:,:,ias),zfmt)
  call zfsht(nr,nri,zfmt,drhomt(:,:,ias))
  deallocate(zfmt)
end do
!$OMP END DO
!$OMP END PARALLEL
! generate the Coulomb potential derivative
call dpotcoul
! add to the Kohn-Sham potential derivative
do ias=1,natmtot
  is=idxis(ias)
  call zfmtadd(nrmt(is),nrmtinr(is),zone,dvclmt(:,:,ias),dvsmt(:,:,ias))
end do
call zaxpy(ngtot,zone,dvclir,1,dvsir,1)
! remove the gradient part of the potential derivative for displaced muffin-tin
call zfmtadd(nrmt(isph),nrmtinr(isph),zone,gvsmt,dvsmt(:,:,iasph))
return
end subroutine

