
! Copyright (C) 2010 J. K. Dewhurst, S. Sharma and E. K. U. Gross.
! This file is distributed under the terms of the GNU General Public License.
! See the file COPYING for license details.

subroutine drhomagsh
use modmain
use modphonon
implicit none
! local variables
integer idm,is,ias
integer nr,nri,nrc,nrci
! allocatable arrays
complex(8), allocatable :: zfmt(:,:)
!$OMP PARALLEL DEFAULT(SHARED) &
!$OMP PRIVATE(zfmt,is,nr,nri) &
!$OMP PRIVATE(nrc,nrci,idm)
!$OMP DO
do ias=1,natmtot
  allocate(zfmt(lmmaxvr,nrcmtmax))
  is=idxis(ias)
  nr=nrmt(is)
  nri=nrmtinr(is)
  nrc=nrcmt(is)
  nrci=nrcmtinr(is)
! convert the density derivative to spherical harmonics
  call zfcpy(nr,nri,drhomt(:,:,ias),zfmt)
  call zfshtl(nrc,nrci,zfmt,drhomt(:,:,ias))
! convert the magnetisation derivative to spherical harmonics
  do idm=1,ndmag
    call zfcpy(nr,nri,dmagmt(:,:,ias,idm),zfmt)
    call zfshtl(nrc,nrci,zfmt,dmagmt(:,:,ias,idm))
  end do
  deallocate(zfmt)
end do
!$OMP END DO
!$OMP END PARALLEL
return

contains

subroutine zfcpy(nr,nri,zfmt1,zfmt2)
implicit none
! arguments
integer, intent(in) :: nr,nri
complex(8), intent(in) :: zfmt1(lmmaxvr,nrmtmax)
complex(8), intent(out) :: zfmt2(lmmaxvr,nrcmtmax)
! local variables
integer ir,irc
irc=0
do ir=1,nri,lradstp
  irc=irc+1
  call zcopy(lmmaxinr,zfmt1(:,ir),1,zfmt2(:,irc),1)
end do
do ir=nri+lradstp,nr,lradstp
  irc=irc+1
  call zcopy(lmmaxvr,zfmt1(:,ir),1,zfmt2(:,irc),1)
end do
return
end subroutine

subroutine zfshtl(nrc,nrci,zfmt1,zfmt2)
implicit none
! arguments
integer, intent(in) :: nrc,nrci
complex(8), intent(in) :: zfmt1(lmmaxvr,nrc)
complex(8), intent(out) :: zfmt2(lmmaxvr,lradstp,nrc)
! local variables
integer ld,nrco,irco
ld=lmmaxvr*lradstp
call zgemm('N','N',lmmaxinr,nrci,lmmaxinr,zone,zfshtinr,lmmaxinr,zfmt1, &
 lmmaxvr,zzero,zfmt2,ld)
nrco=nrc-nrci
if (nrco.eq.0) return
irco=nrci+1
call zgemm('N','N',lmmaxvr,nrco,lmmaxvr,zone,zfshtvr,lmmaxvr,zfmt1(:,irco), &
 lmmaxvr,zzero,zfmt2(:,1,irco),ld)
return
end subroutine

end subroutine

