
! Copyright (C) 2013 J. K. Dewhurst, S. Sharma and E. K. U. Gross.
! This file is distributed under the terms of the GNU General Public License.
! See the file COPYING for license details.

subroutine dwavefmt(lrstp,ias,ngp,ngpq,apwalmq,dapwalm,evecfv,devecfv,dwfmt)
use modmain
use modphonon
implicit none
! arguments
integer, intent(in) :: lrstp,ias,ngp,ngpq
complex(8), intent(in) :: apwalmq(ngkmax,apwordmax,lmmaxapw,natmtot)
complex(8), intent(in) :: dapwalm(ngkmax,apwordmax,lmmaxapw)
complex(8), intent(in) :: evecfv(nmatmax),devecfv(nmatmax)
real(8), intent(out) :: dwfmt(2,lmmaxvr,*)
! local variables
integer is,iro,ld2
integer nrc,nrci
integer irco,nrco
integer l,m,lm,io,ilo
complex(8) z1
! external functions
complex(8) zdotu
external zdotu
ld2=2*lmmaxvr
is=idxis(ias)
iro=nrmtinr(is)+lrstp
if (lrstp.eq.1) then
  nrc=nrmt(is)
  nrci=nrmtinr(is)
else if (lrstp.eq.lradstp) then
  nrc=nrcmt(is)
  nrci=nrcmtinr(is)
else
  write(*,*)
  write(*,'("Error(dwavefmt): invalid lrstp : ",I8)') lrstp
  write(*,*)
  stop
end if
irco=nrci+1
nrco=nrc-nrci
! zero the wavefunction derivative
dwfmt(:,1:lmmaxinr,1:nrci)=0.d0
dwfmt(:,:,irco:nrc)=0.d0
!-----------------------!
!     APW functions     !
!-----------------------!
lm=0
do l=0,lmaxinr
  do m=-l,l
    lm=lm+1
    do io=1,apword(l,is)
      z1=zdotu(ngpq,devecfv,1,apwalmq(:,io,lm,ias),1)
      if (ias.eq.iasph) then
        z1=z1+zdotu(ngp,evecfv,1,dapwalm(:,io,lm),1)
      end if
      if (abs(dble(z1)).gt.1.d-14) then
        call daxpy(nrc,dble(z1),apwfr(1,1,io,l,ias),lrstp,dwfmt(1,lm,1),ld2)
      end if
      if (abs(aimag(z1)).gt.1.d-14) then
        call daxpy(nrc,aimag(z1),apwfr(1,1,io,l,ias),lrstp,dwfmt(2,lm,1),ld2)
      end if
    end do
  end do
end do
do l=lmaxinr+1,lmaxvr
  do m=-l,l
    lm=lm+1
    do io=1,apword(l,is)
      z1=zdotu(ngpq,devecfv,1,apwalmq(:,io,lm,ias),1)
      if (ias.eq.iasph) then
        z1=z1+zdotu(ngp,evecfv,1,dapwalm(:,io,lm),1)
      end if
      if (abs(dble(z1)).gt.1.d-14) then
        call daxpy(nrco,dble(z1),apwfr(iro,1,io,l,ias),lrstp,dwfmt(1,lm,irco), &
         ld2)
      end if
      if (abs(aimag(z1)).gt.1.d-14) then
        call daxpy(nrco,aimag(z1),apwfr(iro,1,io,l,ias),lrstp,dwfmt(2,lm,irco),&
         ld2)
      end if
    end do
  end do
end do
!---------------------------------!
!     local-orbital functions     !
!---------------------------------!
do ilo=1,nlorb(is)
  l=lorbl(ilo,is)
  if (l.le.lmaxinr) then
    do m=-l,l
      lm=idxlm(l,m)
      z1=devecfv(ngpq+idxlo(lm,ilo,ias))
      if (abs(dble(z1)).gt.1.d-14) then
        call daxpy(nrc,dble(z1),lofr(1,1,ilo,ias),lrstp,dwfmt(1,lm,1),ld2)
      end if
      if (abs(aimag(z1)).gt.1.d-14) then
        call daxpy(nrc,aimag(z1),lofr(1,1,ilo,ias),lrstp,dwfmt(2,lm,1),ld2)
      end if
    end do
  else if (l.le.lmaxvr) then
    do m=-l,l
      lm=idxlm(l,m)
      z1=devecfv(ngpq+idxlo(lm,ilo,ias))
      if (abs(dble(z1)).gt.1.d-14) then
        call daxpy(nrco,dble(z1),lofr(iro,1,ilo,ias),lrstp,dwfmt(1,lm,irco),ld2)
      end if
      if (abs(aimag(z1)).gt.1.d-14) then
        call daxpy(nrco,aimag(z1),lofr(iro,1,ilo,ias),lrstp,dwfmt(2,lm,irco), &
         ld2)
      end if
    end do
  end if
end do
return
end subroutine

