
! Copyright (C) 2012 J. K. Dewhurst, S. Sharma and E. K. U. Gross.
! This file is distributed under the terms of the GNU General Public License.
! See the file COPYING for license details.

subroutine gradrhomt
use modmain
use modphonon
implicit none
! local variables
integer nr,nri,ir
! allocatable arrays
complex(8), allocatable :: zfmt(:,:),gzfmt(:,:,:)
! add gradient contribution from rigid shift of muffin-tin
allocate(zfmt(lmmaxvr,nrmtmax),gzfmt(lmmaxvr,nrmtmax,3))
nr=nrmt(isph)
nri=nrmtinr(isph)
! convert the density to complex spherical harmonic expansion
call rtozfmt(nr,nri,1,rhomt(:,:,iasph),1,zfmt)
! compute the gradient
call gradzfmt(nr,nri,rsp(:,isph),zfmt,nrmtmax,gzfmt)
do ir=1,nri
  drhomt(1:lmmaxinr,ir,iasph)=drhomt(1:lmmaxinr,ir,iasph) &
   -gzfmt(1:lmmaxinr,ir,ipph)
end do
do ir=nri+1,nr
  drhomt(:,ir,iasph)=drhomt(:,ir,iasph)-gzfmt(:,ir,ipph)
end do
deallocate(zfmt,gzfmt)
return
end subroutine

