
! Copyright (C) 2013 2010 J. K. Dewhurst, S. Sharma and E. K. U. Gross.
! This file is distributed under the terms of the GNU Lesser General Public
! License. See the file COPYING for license details.

subroutine zfmtctof(zfmt)
use modmain
implicit none
! arguments
real(8), intent(inout) :: zfmt(2,lmmaxvr,nrmtmax,natmtot)
! local variables
integer ld1,ld2,is,ias,lm
integer nr,nri,nro,iro
integer nrc,nrci,nrco
if (lradstp.eq.1) return
ld2=2*lmmaxvr
ld1=ld2*lradstp
!$OMP PARALLEL DEFAULT(SHARED) &
!$OMP PRIVATE(is,nr,nri,nro,iro) &
!$OMP PRIVATE(nrc,nrci,nrco,lm)
!$OMP DO
do ias=1,natmtot
  is=idxis(ias)
  nr=nrmt(is)-2
  nrc=nrcmt(is)
! interpolate up to lmaxinr over entire muffin-tin
  do lm=1,lmmaxinr
! real part
    call rfinterp(nrc,rcmt(1,is),ld1,zfmt(1,lm,1,ias),nr,rsp(2,is),ld2, &
     zfmt(1,lm,2,ias))
! imaginary part
    call rfinterp(nrc,rcmt(1,is),ld1,zfmt(2,lm,1,ias),nr,rsp(2,is),ld2, &
     zfmt(2,lm,2,ias))
  end do
! interpolate up to lmaxvr on outer part of muffin-tin
  nri=nrmtinr(is)
  nro=nrmt(is)-nri-1
  if (nro.le.0) cycle
  iro=nri+1
  nrci=nrcmtinr(is)
  nrco=nrc-nrci+1
  zfmt(:,lmmaxinr+1:lmmaxvr,nri,ias)=0.d0
  do lm=lmmaxinr+1,lmmaxvr
    call rfinterp(nrco,rcmt(nrci,is),ld1,zfmt(1,lm,nri,ias),nro,rsp(iro,is), &
     ld2,zfmt(1,lm,iro,ias))
    call rfinterp(nrco,rcmt(nrci,is),ld1,zfmt(2,lm,nri,ias),nro,rsp(iro,is), &
     ld2,zfmt(2,lm,iro,ias))
  end do
end do
!$OMP END DO
!$OMP END PARALLEL
return
end subroutine

